SystemOrganization addCategory: #'Aeropuerto-Logic'!
SystemOrganization addCategory: #'Aeropuerto-AsientoDeAvion-Test'!
SystemOrganization addCategory: #'Aeropuerto-Avion-Test'!
SystemOrganization addCategory: #'Aeropuerto-Persona-Test'!
SystemOrganization addCategory: #'Aeropuerto-SistemaDeReservas-Test'!
SystemOrganization addCategory: #'Aeropuerto-Vuelo-Test'!
SystemOrganization addCategory: #'Aeropuerto-Pasajes-Test'!

TestCase subclass: #TestAsientoDeAvion
	instanceVariableNames: 'libre reservado confirmado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-AsientoDeAvion-Test'!

!TestAsientoDeAvion methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/9/2012 11:36'!
setUp 
	|persona|
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' nacionalidad: 'Argentino'.
	reservado := AsientoDeAvion newNumero: 73.
	reservado asignarPersona: persona.
	confirmado := AsientoDeAvion newNumero: 37.
	confirmado asignarPersona: persona; confirmar.
	libre := AsientoDeAvion newNumero: 28.! !

Object subclass: #AsientoDeAvion
	instanceVariableNames: 'estado persona numero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!AsientoDeAvion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/8/2012 13:40'!
new
	self error: 'Un asiento de avion necesita un numero, use "newNumero: " '! !

!AsientoDeAvion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/9/2012 10:25'!
newNumero: unNumero
	|asiento|
	asiento := super new.
	asiento numero: unNumero.
	^asiento.! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:22'!
< unAsiento
	^(self numero < unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:22'!
<= unAsiento
	^(self numero <= unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:22'!
= unAsiento
	^(self numero = unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:22'!
> unAsiento
	^(self numero > unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:23'!
>= unAsiento
	^(self numero >= unAsiento numero).! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:02'!
asignarPersona: unaPersona
	((self estaReservado) | (self estaConfirmado))
		ifTrue: [ self error: 'El asiento ya esta Reservado/Confirmado' ]
		ifFalse: [ 
				self estado:  'Reservado'.
				self persona: unaPersona.
			 ]
! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 10:59'!
confirmar
	self estado: 'Confirmado'.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:15'!
esElPasajero: unaPersona
	self persona == unaPersona.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:01'!
estaConfirmado
	^self estado = 'Confirmado'.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:01'!
estaLibre
	^self estado = 'Libre'.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:01'!
estaReservado
	^self estado = 'Reservado'.! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
estado
	^ estado! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
estado: anObject
	estado := anObject! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 10:25'!
initialize 
	self estado: 'Libre'.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:02'!
liberar
	self persona: nil.
	self estado: 'Libre'.! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 11:17'!
numero
	^ numero! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 11:17'!
numero: anObject
	numero := anObject! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
persona
	^ persona! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
persona: anObject
	persona := anObject! !

!AsientoDeAvion methodsFor: 'printing' stamp: 'LeandroGomez 6/9/2012 10:56'!
printOn: aStream
	(self estado = 'Libre')
		ifTrue: [ aStream nextPutAll: 'Asiento numero ', self numero asString , ' libre.']
		ifFalse: [
			
			aStream nextPutAll: 'Asiento numero ', self numero asString ,
								' de ' , self persona nombre, ' ' ,self estado
				].
	! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:00'!
reservar
	self estado: 'Reservado'.! !

Object subclass: #Avion
	instanceVariableNames: 'nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Avion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/8/2012 13:41'!
new
	self error: 'Un avion necesita un nombre , use "newNombre: " '! !

!Avion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/9/2012 11:10'!
newNombre: unNombre 
	|avion|
	avion := super new.
	avion nombre: unNombre.
	^avion! !

!Avion methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:36'!
cantidadDeAsientos 
	self subclassResponsibility.! !

!Avion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:11'!
nombre
	^ nombre! !

!Avion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:11'!
nombre: anObject
	nombre := anObject! !

!Avion methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:27'!
velocidadPromedio
	self subclassResponsibility.! !

Avion subclass: #Comercial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Comercial methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:34'!
cantidadDeAsientos
	^200.! !

!Comercial methodsFor: 'printing' stamp: 'LeandroGomez 6/9/2012 10:58'!
printOn: aStream
	aStream nextPutAll: 'Avion Comercial ', self nombre , ' de ', self asientos size asString ,' asientos'.! !

!Comercial methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:27'!
velocidadPromedio
	^800.! !

Avion subclass: #Jet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Jet methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:34'!
cantidadDeAsientos
	^60.! !

!Jet methodsFor: 'printing' stamp: 'LeandroGomez 6/9/2012 10:58'!
printOn: aStream
	aStream nextPutAll: 'Jet', self nombre , ' de ', self asientos size asString ,' asientos'.! !

!Jet methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:27'!
velocidadPromedio
	^1200.! !

Object subclass: #Pasaje
	instanceVariableNames: 'vuelo persona fReserva nroAsiento'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

Pasaje subclass: #Busiess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Busiess methodsFor: 'operations' stamp: 'LeandroGomez 6/8/2012 13:38'!
costoFijo
	^2000! !

Pasaje subclass: #Economica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Economica methodsFor: 'operations' stamp: 'LeandroGomez 6/8/2012 13:38'!
costoFijo
	^1000! !

!Pasaje methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 01:12'!
coeficienteDeCosto: dias
	| dias1 coef res|
	dias1 := dias.
	coef := 1.
	res := 1.
	[dias1 > (30* coef)] whileTrue: [ res := res+(0.5). coef := coef +1. dias1 := dias1 - (30*coef)].
	^res.! !

!Pasaje methodsFor: 'operations' stamp: 'LeandroGomez 6/8/2012 13:37'!
costo
	^ self costoFijo / (self coeficienteDeCosto: (self vuelo fechaSalida - Date now) days)! !

!Pasaje methodsFor: 'operations' stamp: 'LeandroGomez 6/8/2012 13:39'!
costoFijo
	self subclassResponsibility.! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
fReserva
	^ fReserva! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
fReserva: anObject
	fReserva := anObject! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
nroAsiento
	^ nroAsiento! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
nroAsiento: anObject
	nroAsiento := anObject! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
persona
	^ persona! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
persona: anObject
	persona := anObject! !

!Pasaje methodsFor: 'printing' stamp: 'LeandroGomez 6/8/2012 00:56'!
printOn: aStream
	"Terminar el printOn: "
	aStream nextPutAll:  'Pasaje de: ',self persona printString .! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
vuelo
	^ vuelo! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
vuelo: anObject
	vuelo := anObject! !

Pasaje subclass: #Primera
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Primera methodsFor: 'operations' stamp: 'LeandroGomez 6/8/2012 13:37'!
costoFijo
	^3000! !

Object subclass: #Persona
	instanceVariableNames: 'nombre apellido fnacimiento nacionalidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Persona class methodsFor: 'as yet unclassified' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:45'!
newNombre: unNombre apellido: unApellido fnacimiento: unaFecha nacionalidad: unaNacionalidad
	|persona|
	persona := super new.
	persona nombre: unNombre;
			apellido: unApellido;
			fnacimiento: unaFecha;
			nacionalidad: unaNacionalidad.
	^persona.! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
apellido
	^ apellido! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
apellido: anObject
	apellido := anObject! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
fnacimiento
	^ fnacimiento! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
fnacimiento: anObject
	fnacimiento := anObject! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nacionalidad
	^ nacionalidad! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nacionalidad: anObject
	nacionalidad := anObject! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nombre
	^ nombre! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nombre: anObject
	nombre := anObject! !

!Persona methodsFor: 'printing' stamp: 'LeandroGomez 6/8/2012 13:10'!
printOn: aStream 
	aStream nextPutAll: 'Pasajero ', self nombre, ' ', self apellido , 'de origen ', self nacionalidad.! !

Object subclass: #SistemaDeReservas
	instanceVariableNames: 'pasajes vuelos personas aviones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 10:39'!
aviones
	^ aviones! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 10:39'!
aviones: anObject
	aviones := anObject! !

!SistemaDeReservas methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 10:26'!
imprimirPasajes
	self pasajes do: [:pas | (pas estaReservado | pas estaConfirmado)
								ifTrue: [Transcript show: pas printString; cr.]
							 ]! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
pasajes
	^ pasajes! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
pasajes: anObject
	pasajes := anObject! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
personas
	^ personas! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
personas: anObject
	personas := anObject! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
vuelos
	^ vuelos! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
vuelos: anObject
	vuelos := anObject! !

Object subclass: #Vuelo
	instanceVariableNames: 'origen destino avion fechaSalida estado asientos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

Vuelo subclass: #Internacional
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Internacional methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/9/2012 08:38'!
distaciaPromedio
	^2000.! !

Vuelo subclass: #Transbordo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Transbordo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/9/2012 08:38'!
distaciaPromedio
	^4000.! !

!Vuelo class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/9/2012 11:25'!
newOrigen: unOrigen destino: unDestino avion: unAvion fechaDeSalida: unaFecha
	"unaFecha debe ser un string de la forma <nroDia> <mesEnString> <nroAo>"
	|vuelo|
	vuelo := super new.
	vuelo origen: unOrigen;
		   destino: unDestino;
		   avion: unAvion;
		   fechaSalida: unaFecha asDate;
		   asientos: OrderedCollection new.
		   unAvion cantidadDeAsientos timesRepeat: [ :nro | vuelo asientos add: (AsientoDeAvion newNumero: nro)].
	 ^vuelo.
	! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
avion
	^ avion! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
avion: anObject
	avion := anObject! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 08:26'!
cancelar
	self estado: 'Cancelado'.! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
destino
	^ destino! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
destino: anObject
	destino := anObject! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:31'!
distaciaPromedio
	self subclassResponsibility.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:33'!
duracion
	^ self distaciaPromedio / self avion velocidadPromedio.! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 08:26'!
estado
	^ estado! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 08:26'!
estado: anObject
	estado := anObject! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:49'!
fechaSalida
		^ fechaSalida
	! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:46'!
fechaSalida: anObject
	fechaSalida := anObject! !

!Vuelo methodsFor: 'initialization' stamp: 'LeandroGomez 6/9/2012 11:23'!
initialize 
	self estado: 'Esperando despegue'.! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
origen
	^ origen! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
origen: anObject
	origen := anObject! !

!Vuelo methodsFor: 'printing' stamp: 'LeandroGomez 6/8/2012 13:08'!
printOn: aStream
	"Definir el stream"
	aStream nextPutAll: 'Vuelo desde: ', self origen, ' hasta ', self destino , 
						'. fecha de despegue: ', self fechaSalida asString.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 08:28'!
reprogramarFechaSalida: unaFecha 
	self estado: 'Reprogramado'.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 08:28'!
reprogramarFechaSalida: unaFecha avion: unAvion
	self estado: 'Reprogramado'.
	self avion: unAvion.! !
